- NAME
- SYNOPSIS
- DESCRIPTION
- RETURN VALUES
- SEE ALSO
- COPYRIGHT

# NAME

SSL_dup, SSL_new, SSL_up_ref - create an SSL structure for a connection

# SYNOPSIS

     #include <openssl/ssl.h>

     SSL *SSL_dup(SSL *s);
     SSL *SSL_new(SSL_CTX *ctx);
     int SSL_up_ref(SSL *s);

# DESCRIPTION

SSL_new() creates a new SSL structure which is needed to hold the data for a TLS/SSL connection. The new structure inherits the settings of the underlying context ctx: connection method, options, verification settings, timeout settings. An SSL structure is reference counted. Creating an SSL structure for the first time increments the reference count. Freeing it (using SSL_free) decrements it. When the reference count drops to zero, any memory or resources allocated to the SSL structure are freed.

SSL_up_ref() increments the reference count for an existing SSL structure.

SSL_dup() duplicates an existing SSL structure into a new allocated one. All settings are inherited from the original SSL structure. Dynamic data (i.e. existing connection details) are not copied, the new SSL is set into an initial accept (server) or connect (client) state.

# RETURN VALUES

The following return values can occur:

NULL

  The creation of a new SSL structure failed. Check the error stack to find out the reason.

Pointer to an SSL structure

  The return value points to an allocated SSL structure.

  SSL_up_ref() returns 1 for success and 0 for failure.

# SEE ALSO

SSL_free(3), SSL_clear(3), SSL_CTX_set_options(3), SSL_get_SSL_CTX(3), ssl(7)

# COPYRIGHT

Copyright 2000-2017 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the OpenSSL license (the "License"). You may not use this file except in compliance with the License. You can obtain a copy in the file LICENSE in the source distribution or at https://www.openssl.org/source/license.html.